connect /

set echo on
drop table t;


clear screen
create table t 
as
select * from stage where rownum <= 10000;
create index t_idx on t(owner,object_type,object_name);
analyze index t_idx validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
pause

clear screen
delete from t;
insert into t select * from stage where rownum <= 10000;
analyze index t_idx validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
pause


drop table t;

clear screen
create table t 
as
select * from stage where rownum <= 10000;
create index t_idx on t(owner,object_type,object_name);
analyze index t_idx validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
pause

clear screen
delete from t;
commit;
insert into t select * from stage where rownum <= 10000;
analyze index t_idx validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
pause

drop table t;

clear screen
create table t
(
part_id,
OWNER, OBJECT_NAME, SUBOBJECT_NAME, OBJECT_ID, DATA_OBJECT_ID, OBJECT_TYPE, CREATED,
LAST_DDL_TIME, TIMESTAMP, STATUS, TEMPORARY, GENERATED, SECONDARY, NAMESPACE, EDITION_NAME
)
PARTITION BY list (part_id)
(
  PARTITION part1 VALUES (1),
  PARTITION part2 VALUES (2)
)
as 
select 1, stage.* 
  from stage where rownum <= 10000;
create index t_idx on t(owner,object_type,object_name) local;
pause

clear screen
analyze index t_idx partition (part1) validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
analyze index t_idx partition (part2) validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
pause

clear screen
insert /*+ APPEND */ into t
select 2, stage.* 
  from stage where rownum <= 10000;
alter table t truncate partition part1;
pause


clear screen
analyze index t_idx partition (part1) validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
analyze index t_idx partition (part2) validate structure;
select blocks, lf_blks, lf_rows, del_lf_rows from index_stats;
pause

