connect /
set linesize 100
set echo on
drop table t;
drop table t2 cascade constraints;

clear screen
create table t
as
select rownum sorted, 
       trunc( dbms_random.value( 1, 1000000 ) ) notsorted, 
       stage.*
  from stage
/ 
create index t_sorted on t(sorted);
create index t_notsorted on t(notsorted);
exec dbms_stats.gather_table_stats( user, 'T' );
pause

set echo off
clear screen
prompt Hopefully, you understand that since the index was just built
prompt no amount of rebuilding would ever - in a million years - 
prompt chang the clustering factor...
set echo on
select table_name, blocks, num_rows 
  from user_tables
 where table_name = 'T';
select table_name, index_name, clustering_factor 
  from user_indexes 
 where table_name = 'T' order by index_name;
pause

clear screen
create table t2 as select * from t;
truncate table t;
insert into t select * from t2 order by notsorted;
exec dbms_stats.gather_table_stats( user, 'T', cascade=>true );
pause


clear screen
select table_name, blocks, num_rows 
  from user_tables
 where table_name = 'T';
select table_name, index_name, clustering_factor 
  from user_indexes 
 where table_name = 'T' order by index_name;
pause

